#ifndef _CLIENT_H_
#define _CLIENT_H_

#include "sock.h"
#include "blowfish.h"
#include "constants.h"

enum Functions { Get = 1, Put, Status };

class cClient
{
public:
	cClient();
	~cClient();

	static void* thread (void* param);
	
	static void setPort (int port);
	static void setPassword (const char* pwd);
	static void setCryptoKey (const char* key);
	static void setServervault (const char* vault);
	
	void setCommand (Functions cmd);
	void setStatus (int stat);
	int getStatus ();
	
	char server[128];
	char gamespy[128];
	char character[32];

protected:
	bool run ();
	bool handShake ();
	bool transmitFile (char* pattern, char* localFile);

	void generatePassword (char pwd[128]);
	void createPattern (char* pattern);
	bool findLatestFile (char* pattern, char* filename);
	void sendEncrypted (char* str);
	
private:
	static char serverVault[256];
	static char cryptoKey[128];
	static char password[64];
	static int port;
	
	int status;
	int command;
	CBlowFish fish;
	CSock socket;
};

#endif
