/***************************************************************************
    findfile.cpp - Implementation of the CFindFile class for Vaultster.
    Copyright (C) 2003 Jeroen Broekhuizen (nwnx@jengine.nl)
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ***************************************************************************/

#include "findfile.h"
#include <string.h>

CFindFile::CFindFile()
{
}

CFindFile::~CFindFile()
{
}

bool CFindFile::findFirstFile (char* path)
{
	// try to open the directory
	if ((dir = opendir (path)) == NULL)
		return false;
		
	// see if there are files in the directory
	de = readdir (dir);
	if (de == NULL)
		return false;
	return true;
}

bool CFindFile::findNextFile ()
{
	if (de == NULL || dir == NULL)
		return false;
		
	// save filename, so we can return it
	strcpy (file, de->d_name);
	de = readdir (dir);
	return true;
}

void CFindFile::close ()
{
	// close the directory
	closedir (dir);
	dir = NULL;
}
