#ifndef _SOCKET_H_
#define _SOCKET_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define TIMEOUT(status) ((int)(status) == 0)

class CSock
{
public:
	CSock();
	CSock(const CSock& s);
	~CSock();
	
	bool create (int port = 0);
	void close ();
	
	void listen (int backlog = 5);
	bool accept (CSock& client, sockaddr_in& addr);
	bool connect (char* server, int port);
	
	int send (const void* data, unsigned int size);
	int receive (void* data, unsigned int size, int flags = 0);
	inline int send (const int& i) { return send (&i, sizeof(int)); }
	inline int receive (int& i) { return receive ((void*)&i, sizeof(int)); }
		
	bool sendFile (char* filename, bool compress = true);
	bool receiveFile (char* filename, bool compres = true);
private:
	int sock;
	timeval tv;
};

#endif
